MWAWVariable< T > Struct Template Reference

a generic variable template: value + flag to know if the variable is set More...

`#include <libmwaw_internal.hxx>`

## Public Member Functions

| MWAWVariable ()
| constructor
| MWAWVariable (T const &def)
| constructor with a default value
| MWAWVariable (MWAWVariable const &orig)
| copy constructor
MWAWVariable & | operator= (MWAWVariable const &)=default
| copy operator
MWAWVariable & | operator= (T const &val)
| set a value
void | insert (MWAWVariable const &orig)
| update the current value if orig is set
T const * | operator-> () const
| operator*
T * | operator-> ()
| operator*
T const & | operator* () const
| operator*
T & | operator* ()
| operator*
T const & | get () const
| return the current value
bool | isSet () const
| return true if the variable is set
void | setSet (bool newVal)
| define if the variable is set

## Protected Attributes

T | m_data
| the value
bool | m_set
| a flag to know if the variable is set or not

## Detailed Description

template<class T>
struct MWAWVariable< T >

a generic variable template: value + flag to know if the variable is set

Note
  the variable is considered set as soon a new value is set or when its content is acceded by a function which returns a not-const reference... You can use the function setSet to unset it.
  must be replaced by std::optional when we will be comptable with std::c++-17

## Constructor & Destructor Documentation

## MWAWVariable() [1/3]

template<class T>

MWAWVariable< T >::MWAWVariable | ( |  | ) |

inline

constructor

Referenced by insert(), MWAWVariable(), operator=(), and operator=().

## MWAWVariable() [2/3]

template<class T>

MWAWVariable< T >::MWAWVariable | ( | T const & | def | ) |

inline explicit

constructor with a default value

## MWAWVariable() [3/3]

template<class T>

MWAWVariable< T >::MWAWVariable | ( | MWAWVariable< T > const & | orig | ) |

inline

copy constructor

## Member Function Documentation

## get()

template<class T>

T const & MWAWVariable< T >::get | ( |  | ) | const

inline

return the current value

Referenced by MsWrdStruct::Font::cmp(), MWAWFont::cmp(), MWAWFont::Line::cmp(), MsWrdStruct::Font::insert(), MsWrdStruct::Table::insert(), MsWrdStruct::Font::operator<<, MsWrdStruct::Paragraph::operator<<, MsWrdStruct::Section::operator<<, MsWrdStruct::Table::Cell::operator<<, MsWrdStruct::Table::operator<<, MWAWFont::Line::operator<<, MWAWParagraph::operator<<, RagTime5StyleManager::GraphicStyle::operator<<, MsWrdText::prepareTableLimits(), ClarisDrawText::readParagraph(), ClarisWksText::readParagraph(), HanMacWrdJText::readParagraph(), HanMacWrdKText::readParagraph(), MacWrtParser::readParagraph(), MacWrtProStructures::readParagraph(), MsWks3Text::readParagraph(), MsWrd1Parser::readParagraph(), WordMakerParser::readParagraph(), WriteNowText::readParagraph(), NisusWrtText::readParagraphs(), LightWayTxtText::readRulers(), MsWrdTextStyles::readSection(), MsWrdTextStyles::readStylesFont(), MsWrdTextStyles::setProperty(), NisusWrtText::setProperty(), and RagTime5StyleManager::updateTextStyles().

## insert()

template<class T>

void MWAWVariable< T >::insert | ( | MWAWVariable< T > const & | orig | ) |

inline

update the current value if orig is set

## isSet()

template<class T>

bool MWAWVariable< T >::isSet | ( |  | ) | const

inline

return true if the variable is set

Referenced by MWAWFont::Line::cmp(), ClarisWksStruct::DSET::findForbiddenPagesBreaking(), MsWrdTextStyles::getSectionFont(), MsWrdTextStyles::getSectionParagraph(), MsWrdStruct::Font::insert(), MsWrdStruct::Paragraph::insert(), MsWrdStruct::Table::insert(), MWAWFont::insert(), MWAWParagraph::insert(), RagTime5StyleManager::GraphicStyle::insert(), RagTime5StyleManager::TextStyle::insert(), Canvas5StyleManagerInternal::ColorStyle::operator<<, FullWrtTextInternal::LineHeader::operator<<, MsWrdStruct::Font::operator<<, MsWrdStruct::Paragraph::operator<<, MsWrdStruct::ParagraphInfo::operator<<, MsWrdStruct::Section::operator<<, MsWrdStruct::Table::Cell::operator<<, MsWrdStruct::Table::operator<<, MWAWFont::Line::operator<<, RagTime5StyleManager::GraphicStyle::operator<<, RagTime5StyleManager::TextStyle::operator<<, MsWrdText::prepareParagraphProperties(), MsWrdText::prepareTableLimits(), Canvas5StyleManager::readGradient(), Canvas5StyleManager::readHatch(), MsWrd1Parser::readParagraph(), ClarisWksDocument::updateChildPositions(), Canvas5StyleManager::updateLineColor(), MsWrdStruct::Paragraph::updateParagraphToFinalState(), and Canvas5StyleManager::updateSurfaceColor().

## operator*() [1/2]

template<class T>

T & MWAWVariable< T >::operator* | ( |  | ) |

inline

operator*

## operator*() [2/2]

template<class T>

T const & MWAWVariable< T >::operator* | ( |  | ) | const

inline

operator*

## operator->() [1/2]

template<class T>

T * MWAWVariable< T >::operator-> | ( |  | ) |

inline

operator*

## operator->() [2/2]

template<class T>

T const * MWAWVariable< T >::operator-> | ( |  | ) | const

inline

operator*

## operator=() [1/2]

template<class T>

MWAWVariable & MWAWVariable< T >::operator= | ( | MWAWVariable< T > const & |  | ) |

default

copy operator

## operator=() [2/2]

template<class T>

MWAWVariable & MWAWVariable< T >::operator= | ( | T const & | val | ) |

inline

set a value

## setSet()

template<class T>

void MWAWVariable< T >::setSet | ( | bool | newVal | ) |

inline

define if the variable is set

Referenced by Canvas5StyleManager::readColor().

## Member Data Documentation

## m_data

template<class T>

T MWAWVariable< T >::m_data

protected

the value

Referenced by get(), insert(), MWAWVariable(), MWAWVariable(), MWAWVariable(), operator*(), operator*(), operator->(), operator->(), and operator=().

## m_set

template<class T>

bool MWAWVariable< T >::m_set

protected

a flag to know if the variable is set or not

Referenced by insert(), isSet(), MWAWVariable(), MWAWVariable(), MWAWVariable(), operator*(), operator->(), operator=(), and setSet().

The documentation for this struct was generated from the following file:

- libmwaw_internal.hxx